package com.kjj.qa.cases;

import static com.kjj.qa.config.BasicConfig.*;
import com.kjj.qa.utils.NetworkUtil;
import io.restassured.response.Response;

import org.testng.Assert;
import org.testng.annotations.*;
import org.testng.annotations.Test;


import java.io.IOException;
import java.util.HashMap;
import java.util.Map;


public class Novice {

    private static final NetworkUtil network = NetworkUtil.getInstance();

    @BeforeClass
    public void setUp() {

    }

    //会员判断
    @Test(description="会员判断",priority = 1)
    public void 会员判断() throws IOException{
        Response response = network.getResponse(ISVIPSUBSCRIBE);
        boolean isVip = response.jsonPath().getBoolean("data.vip");
        Assert.assertTrue(true, network.message(ISVIPSUBSCRIBE,"新手任务-会员判断错误"));
    }

    //用户信息
    @Test(description = "用户信息",priority = 2)
    public  void 用户信息()throws IOException{
        Response response = network.getResponse(USER_INFO);
        String wxName = response.jsonPath().getString("data.wxName");
        Assert.assertEquals(wxName,"Su Yi",network.message(USER_INFO,"新手任务-获取用户信息失败"));
    }

    //新手任务列表
    @Test (description = "新手任务列表",priority = 3) //priorty 方法执行优先级
    public void 新手任务列表() throws IOException {
        Response response = network.getResponse(NOVICE_LIST);
        System.out.println(response.getBody().prettyPrint());
        int length = response.jsonPath().getInt("data.size()");
        Assert.assertEquals(length,12,network.message(NOVICE_LIST,"新手任务-任务列表数量不对"));
    }

    // 关注公众号  需要微信回调,无法实现
//    @Test (description = "新手任务_关注公众号",priority = 4) //priorty 方法执行优先级
//    public void 新手任务_关注公众号() throws IOException {
//        //获取列表中"关注公众号"的任务
//        Response response = network.getResponse("/kjy/mp/seller/novice/list");
//
//        //获取任务名为"关注公众号"的任务状态  code: 0未完成 1可领奖励 2已完成
//        int code = response.jsonPath().getInt("data.find {it.taskName == '关注公众号'}.taskStatus.code");
//        Assert.assertEquals(code,0,"关注公众号-任务初始状态 获取失败");
//
//        //关注导师微信号和关注客集集公众号（关注需要微信回调,无法实现）
//
//        //重新获取任务名为"关注公众号"的任务状态，验证任务是否生效
//
//    }

    // 转发文章
    @Test (description = "新手任务_转发文章",priority = 5) //priorty 方法执行优先级
    public void 新手任务_转发文章() throws IOException {
        //获取列表中"转发文章"的任务
        Response response = network.getResponse(NOVICE_LIST);
        //获取任务名为"转发文章"的任务状态  code: 0未完成 1可领奖励 2已完成
        int code = response.jsonPath().getInt("data.find {it.taskName == '转发文章'}.taskStatus.code");
        Assert.assertEquals(code,0,network.message(NOVICE_LIST,"转发文章-任务初始状态 获取失败"));

        //转发文章到朋友圈
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("scId",getScId(ARTICLE_CONTENTID));//文章scId
        params.put("forwardType",1);// 1:个人/微信群 2:朋友圈
        response = network.getResponse(params,FORWARD);
        boolean data = response.jsonPath().getBoolean("data");
        Assert.assertTrue(data, network.message(params, FORWARD,"转发文章-转发到朋友圈 失败"));

        //重新获取任务名为"转发文章"的任务状态，验证任务是否生效
        response = network.getResponse(NOVICE_LIST);
        //获取任务名为"转发文章"的任务状态  code: 0未完成 1可领奖励 2已完成
        code = response.jsonPath().getInt("data.find {it.taskName == '转发文章'}.taskStatus.code");
        Assert.assertEquals(code,1,network.message(NOVICE_LIST,"转发文章-新手任务完成状态 获取失败"));
    }

    // 转发动画
    @Test (description = "新手任务_转发动画",priority = 6) //priorty 方法执行优先级
    public void 新手任务_转发动画() throws IOException {
        //获取列表中"转发动画"的任务
        Response response = network.getResponse(NOVICE_LIST);
        //获取任务名为"转发动画"的任务状态  code: 0未完成 1可领奖励 2已完成
        int code = response.jsonPath().getInt("data.find {it.taskName == '转发动画'}.taskStatus.code");
        Assert.assertEquals(code,0, network.message(NOVICE_LIST,"转发动画-任务初始状态 获取失败"));

        //转发动画到朋友圈
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("scId",getScId(ANIMATION_CONTENTID));//动画scId
        params.put("forwardType",2);// 1:个人/微信群 2:朋友圈
        response = network.getResponse(params,FORWARD);
        boolean data = response.jsonPath().getBoolean("data");
        Assert.assertTrue(data, network.message(params, FORWARD,"转发动画-转发到朋友圈 失败"));

        //重新获取任务名为"转发动画"的任务状态，验证任务是否生效
        response = network.getResponse(NOVICE_LIST);
        //获取任务名为"转发动画"的任务状态  code: 0未完成 1可领奖励 2已完成
        code = response.jsonPath().getInt("data.find {it.taskName == '转发动画'}.taskStatus.code");
        Assert.assertEquals(code,1,network.message(NOVICE_LIST,"转发动画-新手任务完成状态 获取失败"));
    }

    // 转发游戏
    @Test (description = "新手任务_转发游戏",priority = 7) //priorty 方法执行优先级
    public void 新手任务_转发游戏() throws IOException {
        //获取列表中"转发游戏"的任务
        Response response = network.getResponse(NOVICE_LIST);
        //获取任务名为"转发游戏"的任务状态  code: 0未完成 1可领奖励 2已完成
        int code = response.jsonPath().getInt("data.find {it.taskName == '转发游戏(内测中)'}.taskStatus.code");
        Assert.assertEquals(code,0,network.message(NOVICE_LIST,"转发游戏-任务初始状态 获取失败"));

        //转发游戏到朋友圈
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("scId",getScId(GAME_CONTENTID));//游戏scId
        params.put("forwardType",2);// 1:个人/微信群 2:朋友圈
        response = network.getResponse(params,FORWARD);
        boolean data = response.jsonPath().getBoolean("data");
        Assert.assertTrue(data,network.message(params,FORWARD,"转发游戏-转发到朋友圈 失败"));

        //重新获取任务名为"转发游戏"的任务状态，验证任务是否生效
        response = network.getResponse(NOVICE_LIST);
        //获取任务名为"转发游戏"的任务状态  code: 0未完成 1可领奖励 2已完成
        code = response.jsonPath().getInt("data.find {it.taskName == '转发游戏(内测中)'}.taskStatus.code");
        Assert.assertEquals(code,1,network.message(NOVICE_LIST,"转发游戏-新手任务完成状态 获取失败"));
    }

    //上传文章
    @Test (description = "新手任务_上传文章",priority = 8) //priorty 方法执行优先级
    public void 新手任务_上传文章() throws IOException {
        //获取列表中"上传文章"的任务
        Response response = network.getResponse(NOVICE_LIST);

        //获取任务名为"上传文章"的任务状态  code: 0未完成 1可领奖励 2已完成
        int code = response.jsonPath().getInt("data.find {it.taskName == '上传文章'}.taskStatus.code");
        Assert.assertEquals(code,0,network.message(NOVICE_LIST,"上传文章-任务初始状态 获取失败"));

        //上传文章并发到朋友圈 （文章已经在上传case执行过，所以找到那篇文章进行转发就好）
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("pageIndex",1);
        params.put("pageNo",1);
        params.put("pageSize",10);

        //获取我的上传里文章的列表
        params.put("type","article");
        response = network.getResponse(params,UPLOAD_LIST);
        String contentType = response.jsonPath().getString("data[0].contentType");
        String contentId = response.jsonPath().getString("data[0].id");//获取文章的contentd
        Assert.assertEquals(contentType, "article", network.message(params, UPLOAD_LIST,"上传文章-获取我的上传-文章列表数量有误"));




        //转发文章到朋友圈
        Map<String, Object> shareParams = new HashMap<String, Object>();
        shareParams.put("scId",getScId(contentId));
        shareParams.put("forwardType",2);
        response = network.getResponse(shareParams,FORWARD);
        boolean data = response.jsonPath().getBoolean("data");
        Assert.assertTrue(data,network.message(shareParams, FORWARD,"上传文章-发到朋友圈 失败"));

        //重新获取任务名为"上传文章"的任务状态，验证任务是否生效
        response = network.getResponse(NOVICE_LIST);
        //获取任务名为"上传文章"的任务状态  code: 0未完成 1可领奖励 2已完成
        code = response.jsonPath().getInt("data.find {it.taskName == '上传文章'}.taskStatus.code");
        Assert.assertEquals(code,1,network.message(NOVICE_LIST,"上传文章-完成新手任务 失败"));
    }

    // 收到好友转发访问   该接口已废弃
//    @Test (description = "新手任务_收到好友转发访问",priority = 9) //priorty 方法执行优先级
//    public void 新手任务_收到好友转发访问() throws IOException {
//        //获取列表中"收到好友转发访问"的任务
//        Response response = network.getResponse("/kjy/mp/seller/novice/list");
//
//        //获取任务名为"收到好友转发访问"的任务状态  code: 0未完成 1可领奖励 2已完成
//        int code = response.jsonPath().getInt("data.find {it.taskName == '收到好友转发访问'}.taskStatus.code");
//        Assert.assertEquals(code,0,"获取新手任务初始状态-收到好友转发访问 失败");
//
//        //收到好友转发访问
//        network.agentCookies.put("tku",network.visitorTku);        //tku 切换为访客的
//
//        Map<String, Object> params = new HashMap<String, Object>();
//        params.put("scId","Kj20MTMwMDM5");//文章scId
//        params.put("forwardType",2);// 1:个人/微信群 2:朋友圈
//        response = network.getResponse(params,"/kjy/mp/forward");
//        boolean data = response.jsonPath().getBoolean("data");
//        Assert.assertTrue(data,"收到好友转发访问-好友转发到朋友圈 失败");
//
//        network.agentCookies.put("tku",network.agentTku);        //tku 切换为代理人的
//
////        //重新获取任务名为"收到好友转发访问"的任务状态，验证任务是否生效
////        response = network.getResponse("/kjy/mp/seller/novice/list");
////        //获取任务名为"收到好友转发访问"的任务状态  code: 0未完成 1可领奖励 2已完成
////        code = response.jsonPath().getInt("data.find {it.taskName == '收到好友转发访问'}.taskStatus.code");
////        Assert.assertEquals(code,1,"收到好友转发访问-新手任务完成状态 获取失败");
//
//
//
//    }

    //查看访问客户
    @Test (description = "新手任务_查看访问客户",priority = 9) //priorty 方法执行优先级
    public void 新手任务_查看访问客户() throws IOException {
        //获取列表中"查看访问客户"的任务
        Response response = network.getResponse(NOVICE_LIST);

        //获取任务名为"查看访问客户"的任务状态  code: 0未完成 1可领奖励 2已完成
        int code = response.jsonPath().getInt("data.find {it.taskName == '查看访问客户'}.taskStatus.code");
        Assert.assertEquals(code,0,network.message(NOVICE_LIST,"获取新手任务初始状态-查看访问客户 失败"));

        //好友转发一篇我的素材
        network.agentCookies.put("tku",VISITOR_TKU);        //tku 切换为访客的
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("scId",getScId(UPLOAD_CONTENTID));//文章scId
        params.put("forwardType",2);// 1:个人/微信群 2:朋友圈
        response = network.getResponse(params,FORWARD);
        boolean data = response.jsonPath().getBoolean("data");
        Assert.assertTrue(data,network.message(params,FORWARD,"查看访问客户-好友转发到朋友圈 失败"));
        network.agentCookies.put("tku",AGENT_TKU);        //tku 切换为代理人的

        //进入谁看过我，查看访客列表
        Map<String, Object> whoSawMeParams = new HashMap<String, Object>();
        whoSawMeParams.put("pageIndex",1);
        whoSawMeParams.put("pageSize",30);
        response = network.getResponse(whoSawMeParams, WHOSAWME_CUSTCLUELISTV2);
        boolean hasnext = response.jsonPath().getBoolean("data.hasNext");
        int length = response.jsonPath().getInt("data.list.size()");
        Assert.assertNotEquals(0,network.message(whoSawMeParams, WHOSAWME_CUSTCLUELISTV2,"获取谁看过我列表成功"));

        //点击查看，进入线索详情页
        Map<String, Object> noviceParams = new HashMap<String, Object>();
        noviceParams.put("sceneCode","noviceTask_visitorsCustomerInfoComplete");
        response = network.postResponse(noviceParams,NOVICE_MONGOLIANLAYERISPLAY);
        String desc = response.jsonPath().getString("desc");

        //重新获取任务名为"查看访问客户"的任务状态，验证任务是否生效
        response = network.getResponse(NOVICE_LIST);
        //获取任务名为"查看访问客户"的任务状态  code: 0未完成 1可领奖励 2已完成
        code = response.jsonPath().getInt("data.find {it.taskName == '查看访问客户'}.taskStatus.code");
        Assert.assertEquals(code,1, network.message(NOVICE_LIST,"查看访问客户-新手任务完成状态 获取失败"));
    }

    //完善名片  名片改动，此处始终会处于未完成状态，待产品优化
    @Test (description = "新手任务_完善名片",priority = 9) //priorty 方法执行优先级
    public void 新手任务_完善名片() throws IOException {
        //获取列表中"完善名片"的任务
        Response response = network.getResponse(NOVICE_LIST);

        //获取任务名为"完善名片"的任务状态  code: 0未完成 1可领奖励 2已完成
        int code = response.jsonPath().getInt("data.find {it.taskName == '完善名片'}.taskStatus.code");
        Assert.assertEquals(code,0, network.message(NOVICE_LIST,"获取新手任务初始状态-完善名片 失败"));

        //完善名片


        //重新获取任务名为"完善名片"的任务状态，验证任务是否生效
    }


    //获取ScId
    public String getScId (String contentId){
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("contentId",contentId);
        Response response = network.getResponse(params, GETSCID);
        String scId = response.jsonPath().getString("data");
        Assert.assertNotNull(scId,network.message(params, GETSCID,"获取scId失败"));
        return scId;
    }

    @AfterClass
    public static void tearDown(){
        apiCount += 6;
    }
}
