package com.kjj.qa.utils;


import java.sql.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MysqlUtil {
    private static final String PREFIX = "dbseccode";
    private static final String secret = "CNxgrtFG2nYQUfu";

    private static Map<String,MysqlUtil> pool=new HashMap<>();
    //数据库用户名
    private   String USERNAME;// = "root";
    //数据库密码
    private   String PASSWORD; //= "yanzi";
    //驱动信息
    private   String DRIVER="com.mysql.cj.jdbc.Driver";
    //数据库地址
    private   String URL;// = "jdbc:mysql://localhost:3306/mydb";
    private Connection connection;
    private PreparedStatement pstmt;
    private ResultSet resultSet;

    private MysqlUtil(String username,String password,String url){
        USERNAME = username;
        PASSWORD = decode(password);
        URL = url;
        MysqlUtil mu = pool.get(url);
        if(mu!=null){
            System.out.println("--------exists");
            connection = mu.connection;
        }else{
            connection = getConnection();
            pool.put(url,this);
        }
//        if(mu!=null) {
//            try {
//                mu.connection.close();
//            } catch (Exception e) {
//                System.out.println("mysql error:" + e.getMessage());
//            }
//        }
////        }else {
//            connection = getConnection();
//            pool.put(url,this);

    }

    /**
     *
     * @param username   用户名
     * @param password   密码
     * @param ip         数据库ip
     * @param port       端口号
     * @param databaseName  数据库名
     */
    public MysqlUtil(String username,String password,String ip,String port,String databaseName){
        this(username,password,"jdbc:mysql://"+ip+":"+port+"/"+databaseName);
    }

    /**
     * 阿里云数据库连接
     * @param databaseName 数据库名字
     */
    public MysqlUtil(String databaseName){
        this("tuia_test","dbseccode2CJMouQ2xyuEXnhe4vBzGtrDpaDbuK8Lt","47.111.157.152","3306",databaseName);
    }

    public static MysqlUtil mysqlDuiba(String databaseName){
        return new MysqlUtil("tuia_test","dbseccode2CJMouQ2xyuEXnhe4vGtrDpavyDbuK8Lt","47.111.157.152","3306",databaseName);
    }

    /**
     * 获得数据库的连接
     * @return
     */
    public Connection getConnection(){

        try {
            try {
                Class.forName(DRIVER);

            } catch (ClassNotFoundException e) {
                e.printStackTrace();
            }

//            connection = DriverManager.getConnection(URL, USERNAME, PASSWORD);
//            "jdbc:mysql://"+ip+":"+port+"/"+databaseName);
            String url = URL+"?autoReconnect=true&testOnBorrow=true&testWhileIdle=true";
            connection = DriverManager.getConnection(url,USERNAME,PASSWORD);
            System.out.println("数据库连接成功！");
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return connection;
    }
    /**
     * 增加、删除、改
     * @param sql        sql语句
     * @param params     参数，替换 ？
     * @return           true or false
     * @throws SQLException
     */
    public boolean update(String sql, Object ...params)throws SQLException{
        if(!connection.isValid(3)){
            System.out.println("mysql connect is not vaild,reconnect.");
            connection.close();
            connection = getConnection();
            pool.put(URL,this);
        }
        boolean flag = false;
        int result = -1;
        pstmt = connection.prepareStatement(sql);
        int index = 1;
        if(params != null && !(params.length==0)){
            for(int i=0; i<params.length; i++){
                pstmt.setObject(index++, params[i]);
            }
        }

        System.out.println("SQL语句"+pstmt.toString());
        result = pstmt.executeUpdate();

        flag = result > 0 ? true : false;
        return flag;
    }
    /**
     * 查询结果只有一行数据
     * @param sql         sql语句
     * @param params      可变参数，替换 ？
     * @return            map
     * @throws SQLException
     */
    public Map<String, Object> findSimpleResult(String sql, Object ...params) throws SQLException{
        if(!connection.isValid(3)){
            System.out.println("mysql connect is not vaild,reconnect.");
            connection.close();
            connection = getConnection();
            pool.put(URL,this);
        }
        Map<String, Object> map = new HashMap<String, Object>();
        int index  = 1;
        pstmt = connection.prepareStatement(sql);
        if(params != null && !(params.length==0)){
            for(int i=0; i<params.length; i++){
                pstmt.setObject(index++, params[i]);
            }
        }
        System.out.println("sql:"+pstmt.toString());
        resultSet = pstmt.executeQuery();//返回查询结果
        ResultSetMetaData metaData = resultSet.getMetaData();
        int col_len = metaData.getColumnCount();
        while(resultSet.next()){
            for(int i=0; i<col_len; i++ ){
                String cols_name = metaData.getColumnName(i+1);
                Object cols_value = resultSet.getObject(cols_name);
                if(cols_value == null){
                    cols_value = "";
                }
                map.put(cols_name, cols_value);
            }
        }
        return map;
    }

    /**
     * 返回多条数据
     * @param sql           sql语句
     * @param params        可变参数，替换 ？
     * @return              list
     * @throws SQLException
     */
    public List<Map<String, Object>> findModeResult(String sql, Object ...params) throws SQLException{
        if(!connection.isValid(3)){
            System.out.println("mysql connect is not vaild,reconnect.");
            connection.close();
            connection = getConnection();
            pool.put(URL,this);
        }
        List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();
        int index = 1;
        pstmt = connection.prepareStatement(sql);
        if(params != null && !(params.length==0)){
            for(int i=0; i<params.length; i++){
                pstmt.setObject(index++, params[i]);
            }
        }
        resultSet = pstmt.executeQuery();
        ResultSetMetaData metaData = resultSet.getMetaData();
        int cols_len = metaData.getColumnCount();
        while(resultSet.next()){
            Map<String, Object> map = new HashMap<String, Object>();
            for(int i=0; i<cols_len; i++){
                String cols_name = metaData.getColumnName(i+1);
                Object cols_value = resultSet.getObject(cols_name);
                if(cols_value == null){
                    cols_value = "";
                }
                map.put(cols_name, cols_value);
            }
            list.add(map);
        }

        return list;
    }
    /**
     * 释放数据库连接
     */
    public void releaseConn(){
        if(resultSet != null){
            try{
                resultSet.close();
            }catch(SQLException e){
                e.printStackTrace();
            }
        }
    }
    public static void main(String[] args) throws SQLException {
//		JdbcUtils jdbc = new JdbcUtils("root", "root", "com.mysql.jdbc.Driver", "jdbc:mysql://localhost:3306/learning");
//
//		Map<String, Object> map = jdbc.findSimpleResult("select * from t_user where USER_ID='1'", null);

        MysqlUtil jdbcUtils = new MysqlUtil("tuia_adver");
        jdbcUtils.getConnection();
        Map<String, Object> map = jdbcUtils.findSimpleResult("select * from account where company_name=?","对吧科技有限公司");
        jdbcUtils.releaseConn();



    }
    private static String decode(String value) {
        if (value.startsWith(PREFIX)) {
            value = value.substring(PREFIX.length());
            return BlowfishUtils.decryptBlowfish(value, secret);
        }
        return value;
    }

}

